#include "sprpck.h"
//#include <machine/endian.h>

extern BYTE rgb[];
extern BYTE CollRedirect[];

  void  error(int line,char *w, ...);
  void  SaveRGB(char *filename,BYTE *data,int type,int size,int line);
  void  SaveSprite(char *filename,BYTE *data,int len,int line);
  long  LoadFile(char *filename,BYTE **adr);
  long  ConvertFile(BYTE *in,BYTE **raw,long in_size,int type,
                    int *in_w,int *in_h,int off_x,int off_y,int line);

long new_size;

/****************/
BYTE * ConvertPCX(BYTE * in,long in_size,int *in_w,int *in_h,int line)
    {
    int count,count_bpl,x,y,count_planes;
    int shifter,i;
		int bpp,bpl,planes;
    BYTE r,g,b;
    BYTE byte, *new,*pByte,*help;
    long save_insize = in_size;
    
//    if ( *in != 10 || *(in+PCX_VERSION) != 5 || *(in+PCX_ENC) != 1)
//      error(line,"No or unsupported PCX-file !\n");

    *in_w = BLINTEL(in,PCX_XMAX)-BLINTEL(in,PCX_XMIN) +1 ;
    *in_h = BLINTEL(in,PCX_YMAX)-BLINTEL(in,PCX_YMIN) +1 ;
    planes = *(in+PCX_PLANES);

    bpp = (int) *(in+PCX_BPP) ;
    bpl = BLINTEL(in,PCX_BPL) ;

    if ( !((planes == 1 && bpp == 8) || (planes == 4 && bpp == 1) ))
      error(line,"No or unsupported PCX-file !\n");
         
    new_size = (long) (*in_w) * (*in_h)  ;

    if ( (new = malloc(new_size)) == NULL)
      error(line,"Not enough memory !");

  
    if (verbose)
      printf("PXC-size : w = %d h = %d (%d) \n",*in_w,*in_h,bpp);
    
    pByte = in+PCX_RGB;
    help = rgb;
    
    for (x = 16 ; x ; --x)
    {
      r = (*pByte++) >> 4; /* red */
      g = (*pByte++) >> 4; /* green */
      b = (*pByte++) >> 4; /* blue */
      *help++ = g;
      *help++ = ( b<<4 ) | r;
    }
    
    help  = new;
    pByte = in+PCX_DATA;
    
    if ( bpp == 8)
    {
      x = *in_w+1;
      count_bpl = bpl;
      in_size = new_size;
      while (in_size > 0)
      {
        if ( ((byte = *pByte++) & 0xc0 )== 0xC0 )
        {
          count = byte & 0x3f;
          byte = *pByte++;
          do{
            if ( x-- ) { *help++ = byte & 15; --in_size; }
            --count_bpl;
            if ( ! count_bpl ) { x = *in_w+1;  count_bpl = bpl; }
          }while (--count);
        }
        else
        {
          if ( x-- ) { *help++ = byte & 15; --in_size; }
          --count_bpl;
          if ( !count_bpl ) { x = *in_w+1; count_bpl = bpl; }
        }
      } /*while*/
      if ( pByte != in+save_insize )
      {
        pByte = in+save_insize-16*3;
        help = rgb;
    
        for (x = 16 ; x ; --x)
        {
          r = (*pByte++) >> 4; /* red */
          g = (*pByte++) >> 4; /* green */
          b = (*pByte++) >> 4; /* blue */
          *help++ = g;
          *help++ = ( b<<4 ) | r;
        }
        if (verbose) printf("PCX:Using palette at the end of file !\n");
      }      
    }
    else  // 1bit / 8 planes
    {
      for ( y = *in_h; y ; --y, help += *in_w)
      {
        for (i = *in_w ; i ; --i)
          *(help+i) = 0;

        for (count_planes = planes, shifter = 1;
             count_planes;
             --count_planes, help -= *in_w, shifter <<=1)
          for ( x = *in_w ; x ; ) 
            if ( ( (byte = *pByte++) & 0xc0 ) == 0xc0 )
              { 
                count = byte & 0x3f;
                byte = *pByte++;
                do
                {
                  for (i = 0x80; x && i; i>>=1, --x)
                    if  (byte & (BYTE)i)
                      *help++ |= shifter;
                    else
                      help++; 
                  --count;
                }while ( count );
              }
              else
              { 
                for (i = 0x80; x   && i  ; i>>=1, --x) 
                  if  (byte & i)
                    *help++ |= shifter;  
                  else
                    help++;         
              } 
           
      }/*for (y ..*/
    }
   help = new;
   for (in_size = new_size ; in_size ; --in_size)
     *help++ &=15;
     
   free(in);
   return ( new );
}
/************************/
/* main conversion-loop */
/************************/
long ConvertFile(BYTE *in,BYTE **raw,long in_size,int type,
                   int *in_w,int *in_h,int off_x,int off_y,int line)
{
  BYTE *pByte = NULL,*help;
 
  new_size = 0;

  switch (type)
  {
  case TYPE_RAW1:
    {
    int bit;
    signed char byte;

    new_size = in_size << 3;
    
    if ( (*raw = malloc(new_size)) == NULL)
      error(line,"Not enough memory !");
    pByte = *raw;
    help = in;
    while (in_size)
    {
      byte = *help++;
      for (bit = 8 ; bit ; byte <<= 1 , --bit )
        *pByte++ = (byte < 0) ? 1 : 0;
        
      --in_size;
    }
    }
    free(in);
    break;

  case TYPE_RAW4:
    new_size = in_size<<1;
    if ( (*raw = malloc(new_size)) == NULL)
      error(line,"Not enough memory !");
    pByte = *raw;
    help = in;
    while (in_size)
    {
      *pByte++ = (*help)>>4;
      *pByte++ = (*help++) & 0xf;
      --in_size;
    }
    free(in);
    break;
  case TYPE_RAW8:
    *raw = in;
    new_size = in_size;
    break;
  case TYPE_SPS:
    pByte = *raw = in;
    while (in_size)
    {
      BYTE b = *in++;
      --in_size;
      if ( b < ' ' ) continue;
      if ( ' ' == b )
      {
        b = 0;      }
      else if (('0' <= b) && (b <= '9'))
      {
        b = b - '0';
      }
      else if (('A' <= b) && (b <= 'F'))
      {        b = b - 'A' + 10;
      }
      else if (('a' <= b) && (b <= 'f'))
      {
        b = b - 'a' + 10;
      }
        
      *pByte++ = b;
      ++new_size;
    }
    break;
  case TYPE_PCX:
    *raw = ConvertPCX(in,in_size,in_w,in_h,line);
    break;
	case TYPE_PI1:
    {
      int i,o;
      BYTE r,b,g;
      
			*in_w = 320;
			*in_h = 200;

      *raw = malloc(new_size = 64000);
    
      help = in + 2;  // skip first 2 bytes

			pByte = rgb;	    

      for ( i = 0; i < 16 ; ++i)
      {
        if ( (r = ((*help++) & 0x07) << 1) ) ++r;
        if ( (g = (*help     & 0x70) >> 3) ) ++g;
        if ( (b = ((*help++) & 0x07) << 1) ) ++b;

	// printf("r %x g %x b %x \n",r,g,b);

        *pByte++ = g;
        *pByte++ = (b<<4) | r;
      }
      
      pByte = *raw;
      
      for ( i = 4000; i ; --i)
      {
				USHORT w0,w1,w2,w3;
	
				w3 = *((USHORT *)help)++;
				w2 = *((USHORT *)help)++;
				w1 = *((USHORT *)help)++;
				w0 = *((USHORT *)help)++;	

				for ( o = 16 ; o ; --o )
				{
					*pByte++ = (w0>>12)&8 | (w1>>13)&4 | (w2>>14)&2 | (w3>>15);
					w0 <<= 1;
					w1 <<= 1;
					w2 <<= 1;
					w3 <<= 1;
				}
			} 
}
	 break;

 } /*switch*/
/* input file is converted, now ... */


/* handle offset */
  if ( (off_x + off_y) != 0)
  {
    char *help,*help1;
    int x,y;

    help = *raw;
    
    help1 = *raw + off_y * (*in_w);
 
     *in_h -= off_y;
     *in_w -= off_x;

    for ( y = *in_h ; y ; --y)
    {
      help1 += off_x;
      for ( x = *in_w ; x ; --x)
        *help++ = *help1++;
    }
    new_size = (*in_w) * (*in_h);
  }

  return (new_size);     
}

long LoadFile(char fn[],BYTE **ptr)
{ 
  long len;
  int f;
  
  if ((f = open(fn,O_RDONLY | O_BINARY)) >= 0)
  { 
    len = lseek(f,0L,SEEK_END);
    lseek(f,0L,SEEK_SET);
    if ( ( *ptr=malloc(len) ) == NULL)
      return 0;
#ifdef DEBUG
  printf("filesize: %ld\n", len);
#endif
    len  = read(f,*ptr,len);
#ifdef DEBUG
      printf("bytes read: %ld\n", len);
#endif
    close(f);
    if (verbose) printf("Read: %s \n",fn);

    return (len);
  }else
    return 0;
}

void SaveRGB(char *filename,BYTE *pal,int type,int size,int line)
{
  int i;
  FILE *f;
  BYTE *pal2 = pal+1,g,br;
  BYTE *pCollRedirect = CollRedirect;
  
  if ( (f = fopen(filename,"w") ) == NULL)
    error(line,"Couln't write color-table !\n");  
  switch (type){
  case C_HEADER:
  
    fprintf(f,"char redir[]={");
    for (i = 1<<(size-1) ; i ; --i)
    { 
      g = *pCollRedirect++;
      br = *pCollRedirect++;
      fprintf(f,"0x%02X",(g<<4)|br);
      if (i > 1)
        putc(',',f);
    }
   
    fprintf(f,"};\nchar pal[]={\n\t");
    for (i = 16 ; i ; --i , pal += 2)
      fprintf(f,"0x%02X,",(int)*pal);
    fprintf(f,"\n\t");
    for (i = 16 ; i ; --i , pal2 += 2)
      if ( i > 1 )
        fprintf(f,"0x%02X,",(int)*pal2);  
      else
        fprintf(f,"0x%02X};\n",(int)*pal2);
   
    break;
    
  case ASM_SRC:
    fprintf(f,"redir:\tdc.b ");
    for (i = 1<<(size-1) ; i ; --i)
    { 
      g = *pCollRedirect++;
      br = *pCollRedirect++;
      fprintf(f,"$%02X",(g<<4)|br);
      if (i > 1)
        putc(',',f);
    }
    fprintf(f,"\npal:\tdc.b ");
    for (i = 16; i ; --i , pal += 2)
      if ( i > 1 ) fprintf(f,"$%02X,",(int)*pal);
    else
      fprintf(f,"$%02X\n\tdc.b ",(int)*pal);
      
    for (i = 16; i ; --i , pal2 += 2)
      if ( i > 1 ) fprintf(f,"$%02X,",(int)*pal2);
    else
      fprintf(f,"$%02X\n",(int)*pal2);
      
    break;
  case LYXASS_SRC:
    fprintf(f,"redir:\tdc.b ");
    for (i = 1<<(size-1) ; i ; --i)
    { 
      g = *pCollRedirect++;
      br = *pCollRedirect++;
      fprintf(f,"$%02X",(g<<4)|br);
      if (i > 1)
        putc(',',f);
    }

    fprintf(f,"\npal:\tDP ");
    for (i = 16; i ; --i)
    { g = *pal++; br = *pal++;
      if ( i > 1 )
        fprintf(f,"%X%02X,",g,br);
      else
        fprintf(f,"%X%02X\n",g,br);
    }
    break;
  }/*switch*/
      
  fclose(f);
  if (verbose)
    printf("%s written.\n",filename);
}

void SaveSprite(char *filename,BYTE *ptr,int size,int line)
{
   int handle;
   
  if ( (handle = open(filename,O_CREAT | O_TRUNC | O_BINARY | O_RDWR, 0644)) <0 )
  {
    error(line,"Couldn't open %s for writing !\n",filename);
  }
  if ( write(handle,ptr,size) != size )
    printf("Error: Couldn't write %s !\n",filename);
  else
    if (verbose)
      printf("Written: %s \n"
             "--------------------------\n",filename);
 
  close(handle);
}

void error(int line,char *f,...)
{
  va_list argp;
  
  va_start(argp,f);
  printf("Error (%d):",line);
  printf(f,va_arg(argp,char *) );
  va_end(argp);
#ifdef ATARI
  while (getc(stdin) != ' ');
#endif
  exit(-1);
}
